<template>
    <section class="registrationForm">
      <form class="registrationFields" @submit.prevent="registerUser">
        <div class="inputFields">
          <h1 class="signUp">Sign Up</h1>
          
          <div class="inputLabels">
            <label class="label" for="username">Username</label>
            <input
              class="inputBoxes"
              type="text"
              id="username"
              v-model="username"
              required
            />
            <span class="error-message" v-if="error.username">{{ error.username }}</span>
          </div>
  
          <div class="inputLabels">
            <label class="label" for="email">Email</label>
            <input
              class="inputBoxes"
              type="email"
              id="email"
              v-model="email"
              required
            />
            <span class="error-message" v-if="error.email">{{ error.email }}</span>
          </div>
  
          <div class="inputLabels">
            <label class="label" for="password">Password</label>
            <input
              class="inputBoxes"
              type="password"
              id="password"
              v-model="password"
              required
            />
            <span class="error-message" v-if="error.password">{{ error.password }}</span>
          </div>
  
          <div class="inputLabels">
            <label class="label" for="confirmPassword">Confirm Password</label>
            <input
              class="inputBoxes"
              type="password"
              id="confirmPassword"
              v-model="confirmPassword"
              required
            />
          </div>
          
        </div>
        
        <button class="registerButton" type="submit">
          <b class="signUpText">Sign Up</b>
        </button>
        
        <span class="success-message" v-if="success">{{ success }}</span>
  
        <div class="alreadyHaveAnContainer">
          <span class="alreadyHaveAn">Already have an account? </span>
          <b class="loginHere" @click="$emit('show-login')">Log in here</b>
        </div>
      </form>
    </section>
  </template>
  
  <script lang="ts">
  import { defineComponent, ref } from 'vue';
  
  export default defineComponent({
    name: 'RegistrationForm',
    emits: ['show-login'],
    setup() {
      const username = ref('');
      const email = ref('');
      const password = ref('');
      const confirmPassword = ref('');
      const error = ref({
        username: '',
        email: '',
        password: '',
      });
      const success = ref('');
  
      const registerUser = async () => {
        // Clear previous error messages
        error.value.username = '';
        error.value.email = '';
        error.value.password = '';
        success.value = '';
  
        // Implement registration API call here
        try {
          const response = await fetch('http://localhost:8000/api/register', {
            method: 'POST',
            headers: {
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({
              username: username.value,
              email: email.value,
              password: password.value,
            }),
          });
  
          if (!response.ok) {
            const data = await response.json();
            const errorMessage = data.detail;
            if (errorMessage.includes("Username already registered.")) {
              error.value.username = "This username is already taken.";
            }
            if (errorMessage.includes("Email already registered.")) {
              error.value.email = "This email is already registered.";
            }
          } else {
            // Handle successful registration
            success.value = "Registration successful! You can now log in.";
          }
        } catch (err) {
          console.error(err);
          error.value.password = "An unexpected error occurred. Please try again.";
        }
      };
  
      return {
        username,
        email,
        password,
        confirmPassword,
        error,
        success,
        registerUser,
      };
    },
  });
  </script>
  
  <style scoped>
  .registrationForm {
    width: 100%;
    display: flex;
    justify-content: center;
    padding: 0 var(--padding-20xl) 0 var(--padding-19xl);
  }
  
  .registrationFields {
    width: 100%;
    max-width: 400px; /* Increased width for a more spacious layout */
    margin: 0;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: flex-start;
    gap: var(--gap-34xl);
    background-color: #1e1e2f; /* Background color for the form */
    padding: 20px; /* Add padding for spacing */
    border-radius: 8px; /* Rounded corners */
    box-shadow: 0 4px 20px rgba(0, 0, 0, 0.2); /* Subtle shadow for depth */
  }
  
  .inputFields {
    width: 100%;
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    gap: var(--gap-4xl);
  }
  
  .signUp {
    margin: 0;
    width: 100%;
    font-size: var(--font-size-13xl);
    font-family: var(--font-audiowide);
    color: var(--color-white);
    text-align: center;
  }
  
  .inputLabels {
    width: 100%;
    display: flex;
    flex-direction: column;
    gap: var(--gap-7xs);
  }
  
  .label {
    font-size: var(--font-size-base);
    font-family: var(--font-open-sans);
    color: var(--color-white);
  }
  
  .inputBoxes {
    width: 100%;
    border: 2px solid var(--color-white);
    background-color: #29293d; /* Darker input background */
    height: 45px;
    border-radius: 8px; /* Matching rounded corners */
    padding: 0 10px;
    color: var(--color-white);
    font-family: var(--font-open-sans);
    transition: all 0.3s ease; /* Smooth transition for focus */
  }
  
  .inputBoxes:focus {
    border-color: #ae45c9; /* Focused border color */
    background-color: #3b3b4f; /* Change background on focus */
    outline: none; /* Remove default outline */
  }
  
  /* Updated button styles */
  .registerButton {
    cursor: pointer;
    border: none;
    padding: 15px 25px; /* Increased padding for a larger button */
    background-color: #ae45c9; /* Vibrant purple background color */
    border-radius: 8px; /* Rounded corners */
    display: flex;
    align-items: center;
    justify-content: center;
    font-size: 1rem; /* Consistent font size */
    font-family: var(--font-open-sans);
    color: white; /* White text color */
    transition: background 0.3s ease, transform 0.2s; /* Smooth transition */
    margin-top: 15px; /* Added margin for spacing */
  }
  
  .registerButton:hover {
    background-color: #9c3cb6; /* Darker purple on hover */
    transform: scale(1.05); /* Slightly enlarge on hover */
  }
  
  .signUpText {
    font-weight: bold;
  }
  
  .alreadyHaveAnContainer {
    width: 100%;
    font-size: var(--font-size-base);
    color: var(--color-white);
    text-align: center;
    cursor: pointer;
  }
  
  .alreadyHaveAn,
  .loginHere {
    font-family: var(--font-open-sans);
  }
  
  .loginHere {
    text-decoration: underline;
    font-weight: bold;
  }
  
  .error-message {
    color: red;
    font-size: 0.875em;
  }
  
  .success-message {
    color: green;
    margin-top: 10px;
  }
  </style>
  